﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DEVSsharp;
using System.IO;

namespace NebeskaTela
{
    class Stampac : Atomic
    {
        public InputPort inputPortPozicija;
        public InputPort inputPortKometaPoruka;
        public InputPort inputPortKometaUdarac;

        StreamWriter sw;

        NebeskoTeloPoruka sunce, zemlja, mesec;

        public KometaPoruka kometa;
        public KometaPorukaUdarac kometaUdarac;

        public Stampac(string name, TimeUnit tu, NebeskoTeloPoruka s, NebeskoTeloPoruka z, NebeskoTeloPoruka m) : base(name, tu)
        {
            this.sunce = s;
            this.zemlja = z;
            this.mesec = m;

            inputPortPozicija = AddIP("inputPortPozicija");
            inputPortKometaPoruka = AddIP("inputPortKometaPoruka");
            inputPortKometaUdarac = AddIP("inputPortKometaUdarac");
        }

        public override bool delta_x(PortValue x)
        {
            if(x.port == inputPortPozicija)
            {
                NebeskoTeloPoruka ntp = (NebeskoTeloPoruka)x.value;

                if (ntp.name.Equals("Sunce"))
                    sunce = ntp;
                if (ntp.name.Equals("Zemlja"))
                    zemlja = ntp;
                if (ntp.name.Equals("Mesec"))
                    mesec = ntp;
            }
            else if(x.port == inputPortKometaPoruka)
            {
                KometaPoruka kp = (KometaPoruka)x.value;
                kometa = kp;
            }
            else if(x.port == inputPortKometaUdarac)
            {
                kometaUdarac = (KometaPorukaUdarac)x.value;
            }

            string str = string.Format("{0},{1},{2},{3},{4},{5}", sunce.pozicija.X, sunce.pozicija.Y, zemlja.pozicija.X, zemlja.pozicija.Y, mesec.pozicija.X, mesec.pozicija.Y);
            if (kometa != null)
            {
                str += string.Format(",{0},{1}", kometa.kometa.X, kometa.kometa.Y);
            }
            if(kometaUdarac != null)
            {
                str += string.Format(",Kometa {0} je udarila u {1}", kometaUdarac.kometa, kometaUdarac.telo);
                kometaUdarac = null;
                kometa = null;
            }

            sw.WriteLine(str);
            sw.Flush();

            return false;
        }

        public override void delta_y(ref PortValue y)
        {
            
        }

        public override void init()
        {
            kometa = null;
            if (sw != null)
                sw.Close();
            sw = new StreamWriter("izlaz.csv");
            sw.WriteLine("{0},{1},{2},{3},{4},{5}", sunce.pozicija.X, sunce.pozicija.Y, zemlja.pozicija.X, zemlja.pozicija.Y, mesec.pozicija.X, mesec.pozicija.Y);
            sw.Flush();
        }

        public override double tau()
        {
            return double.MaxValue;
        }
    }
}
