﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NebeskaTela
{
    public class Vektor
    {
        public double X { get; set; }
        public double Y { get; set; }

        public Vektor() { }

        public Vektor(double x, double y)
        {
            X = x;
            Y = y;
        }

        public double Length()
        {
            return Math.Sqrt(X * X + Y * Y);
        }

        public override string ToString()
        {
            return "(" + X + "," + Y + ")";
        }

        public void RotateAroundPoint(Vektor c, double angle)
        {
            angle = 1.0 * angle * Math.PI / 180.0;
            double sin = Math.Sin(angle);
            double cos = Math.Cos(angle);

            X -= c.X;
            Y -= c.Y;

            double tempX = X * cos - Y * sin;
            double tempY = X * sin + Y * cos;

            X = tempX + c.X;
            Y = tempY + c.Y;
        }

        public static Vektor operator +(Vektor v1, Vektor v2)
        {
            return new Vektor(v1.X + v2.X, v1.Y + v2.Y);
        }

        public static Vektor operator -(Vektor v1, Vektor v2)
        {
            return new Vektor(v1.X - v2.X, v1.Y - v2.Y);
        }

        public static Vektor operator *(Vektor v, double num)
        {
            return new Vektor(v.X * num, v.Y * num);
        }
    }
}
